include filenames.prg
include special_cases.prg

!doGUI = 1 ' default is GUI dialog
create(wf=eviewstemp) u 10 ' temp wf for holding some temp objects

subroutine extract(string %freq)
	pagecontract if series01<>na
	' extract
	if ((%freq = "bday") or (%freq = "weekly")) then
		pagecopy(page=%freq, smpl="if series01>1000000")
		series date = @dateval(@str(series01), "YYYYMMDD")
		if %freq = "bday" then
			pagestruct(freq=D5) @date(date)
		else 
			pagestruct(freq=D7) @date(date)
		endif
	else         
		if ((%freq = "monthly") or (%freq = "quarterly")) then
			pagecopy(page=%freq, smpl="if series01>10000")
			series date = @dateval(@str(series01), "YYYYMM")
			pagestruct @date(date)
		else ' annual
			pagecopy(page=%freq, smpl="if series01<10000")
			pagestruct @date(series01)
		endif
	endif
	delete series01
	pageselect Untitled
endsub

subroutine not_found(string %missing)
	%error = "Error: " + %missing + " not found."
	@uiprompt(%error)
	wfclose Untitled
	stop
endsub

' some parameters
svector snames = @wsplit(%names)	
svector sfilenames = @wsplit(%filenames)
!num_allnames = @rows(snames)

' user has chosen to use the command line
if @len(%args) > 0 then
	!doGUI = 0
endif
if !doGUI = 0 then
	%files = @stripquotes(%0)
	' fill the vector with numbers of the chosen files
	svector sfiles = @wsplit(%files)
	!num_files = @rows(sfiles)
	vector(!num_files) selected
	for !n = 1 to !num_files
		if @instr(%names, sfiles(!n)) then
			for !m = 1 to !num_allnames
				if sfiles(!n) = snames(!m) then
					selected.fill(o=!n) !m 
				endif
			next
		else
			' check filenames were entered correctly
			call not_found(sfiles(!n))
		endif
	next
endif

' user has chosen to use the GUI
if !doGUI = 1 then
	vector(1) selected
	selected.fill -1
	!types = @uimlist(selected, "Import:", %names)
	if !types = -1 then
		stop
	endif
endif

' main
%page = "http://mba.tuck.dartmouth.edu/pages/faculty/ken.french/ftp/"
%base = "cscript //nologo "
%dwn = @addinspath + "\frenchdata\download.vbs"
%unz = @addinspath + "\frenchdata\unzip.vbs"
!num_selected = @rows(selected)
for !i = 1 to !num_selected
	wfselect eviewstemp
	%zipfile = sfilenames(selected(!i))
	%series_name = snames(selected(!i))
	' make dir in %temp% folder to hold files
	if @instr(%zipfile, "CSV") then
		%rootname = @wreplace(%zipfile, "*_CSV.zip", "*")
	else
		%rootname = @wreplace(%zipfile, "*.zip", "*")
	endif
	%ziploc = "%temp%\" + %rootname
	%unzloc = "%temp%\" + %rootname + "\unz"
	' find temp dir on system and create dirs for fetching & unzipping
	shell if exist %ziploc rd /s /q %ziploc
	shell mkdir %ziploc	
	shell mkdir %unzloc	
	' make commands
	%fetch = %base + """" + %dwn + """ " + %page + %zipfile + " " + %ziploc + "\" + %zipfile ' download
	%unzcom = %base + """" + %unz + """ " + %ziploc + "\" + %zipfile + " " + %unzloc ' unzip
	' get name of unzipped file for wfopen
	' some data only come in txt format - everything else is downloaded as csv
	shell("h", out=temp) echo %ziploc
	%zipf = @stripquotes(temp(1, 1))
	%unzf = %zipf + "\unz"
	delete temp
	' fetch
	shell {%fetch}
	' some files need more time to download
	' try to unzip
	shell {%unzcom}
	' string list of unzipped files, if any
	%unzipped = @wdir(%unzf)
	%openf = %unzf + "\" + @word(%unzipped, 1)
	' test if download is finished by seeing if unzipped file(s) exists yet
	while @fileexist(%openf) = 0 
		' try unzip again
		shell {%unzcom}
		sleep 500
		%unzipped = @wdir(%unzf)
		%openf = %unzf + "\" + @word(%unzipped, 1)
	wend
	' special cases, of which there are many
	if @wfindnc(%series_name, "Industry") or @wfindnc(%series_name, "Formed") then
		' these four files need a lot of attention
		if @wfindnc(%series_name, "Country") or @wfindnc(%series_name, "Index") then
			%names = "(date,mkt, "
			%more = @wcross("be_me e_p ce_p yld", "high low", "?_?")
			%more = @wdelim(%more, " ", ",")
			%namesplus = %names + %more + ",yld_zero)"
			%pages = " valwgt_dret_nr_m valwgt_lret_nr_m valwgt_dret_r_m valwgt_lret_r_m valwgt_dret_nr_y valwgt_lret_nr_y valwgt_dret_r_y valwgt_lret_r_y valwgt_nr_y valwgt_r_y "
			for %c {%unzipped}
				if @wfindnc(%c, "Malaysia.Dat") = 0 then ' use "Malaysia    .Dat" not "Malaysia.Dat"
					%openf = %unzf + "\" + %c
					wfopen(page=Untitled) %openf na="-99.99" skip=4 colhead=0 names=%namesplus
					series chunk = @recode(@trend=0, 1, _
					@recode(date=na, chunk(-1)+1, _
					@recode(date(-1)=na, chunk(-1)+1, chunk(-1))))
					!p = 1
					for !j=1 to @max(chunk)-1 ' -1 to skip last copyright line
						pageselect Untitled
						smpl if chunk = !j
						if @obssmpl > 1 then
							smpl @all
							%smplstr = "if chunk=" + @str(!j)
							%pagen = @word(%pages,!p)
							pagecopy(page=%pagen, smpl=%smplstr)
							pagestruct @date(date)
							' different structure at end of files
							if !p = 9 or !p = 10 then
								'if @wfindnc(%series_name, "Index") then
								'delete yld_zero
								'else
								'delete e_p* ce_p*
								rename mkt firms
								rename be_me_high b_m
								rename be_me_low e_p
								rename e_p_high ce_p
								rename e_p_low yld
								delete *_high *_low yld_zero
								'endif	
							endif
							!p = !p + 1
							delete chunk
						endif
						smpl @all
					next
					pagedelete Untitled
				endif
			next
		else
			' most files go through here
			' find where data starts
			wfopen(page=Untitled) %openf scan=1 emptylines=keep
			!start = 1
			while @val(series01(!start)) = NA
				!start = !start + 1
			wend
			!start = !start - 3 ' take out text at beginning of files
			wfclose 
			' read it in again
			wfopen(page=Untitled) %openf na="-99.99" skip=!start scan=2 colhead=0 
			call multiset_divide
		endif
	else ' special header treatment
		if @wfindnc(%series_name, "Breakpoints") then 
			if @instr(%series_name, "E/P") or _
				@instr(%series_name, "D/P") or _
				@instr(%series_name, "BE/ME") or _
				@instr(%series_name, "CF/P") then
				%names = "(series01, count_le_0, count_gt_0"
			else
				%names = "(series01, Count"
			endif
			for !t=5 to 100 step 5
				%names = %names + ", "
				%new = "pctl" + @str(!t)
				%names = %names + %new
			next					
			%names = %names + ")"
			wfopen(page=Untitled) %openf na="-99.99" colhead=0 names=%names
			if @instr(%series_name, "CF/P") or _
				@instr(%series_name, "Operating") or _
				@instr(%series_name, "BE/ME") or _
				@instr(%series_name, "Investment") or _
				@instr(%series_name, "E/P") then
				call extract("annual")
			else
				call extract("monthly")
			endif
		else ' special header treatment
			if @wfindnc(%series_name, "Historical") then 
				%names = "(CRSP_Permno, First_Moody_Year, Last_Moody_Year"
				for !k=1925 to 2001
					%names = %names + ", "
					%new = "year" + @str(!k + 1)
					%names = %names + %new
				next
				%names = %names + ")"
				wfopen(page=hist_book_eq_data) %openf na="-99.99" colhead=0 names=%names
			else ' everything else
				if @instr(%series_name, "Benchmark Factors") then
					%names = "(series01, Rm-Rf, SMB, HML)" ' monthly & annual have space in rm-rf
					wfopen(page=Untitled) %openf na="-99.99" colhead=0 skip=1 names=%names
				else
					wfopen(page=Untitled) %openf na="-99.99"
				endif
				if @wfindnc(%series_name, "[Daily]") then
					call extract("bday")
				else 
					if @wfindnc(%series_name, "[Weekly]") then
						call extract("weekly")
					else
						if @wfindnc(%series_name, "[Quarterly]") then
							call extract("quarterly")						
						else
							if @wfindnc(%series_name, "[Monthly]") then
								call extract("monthly")		
							else
								if @wfindnc(%series_name, "[Annual]") then
									call extract("annual")		
								else
									call extract("monthly")
									call extract("annual")
								endif
							endif
						endif
					endif
				endif
			endif	
		endif	
		if @pageexist("Untitled") then
			pagedelete Untitled
		endif
	endif
	' delete temp folder
	shell if exist %ziploc rd /s /q %ziploc
next

wfclose eviewstemp


